package mmstream.connection.ip;

import mmstream.*;
import mmstream.util.*;
import mmstream.address.*;
import mmstream.connection.*;
import mmstream.connection.ip.*;

import java.net.*;

public abstract class IP_Connection implements Connection {

public abstract void 
send(byte[] m, int reserved, int length) throws IP_Connection_Exception;  
public abstract void 
send(byte[] m, int length) throws IP_Connection_Exception;  
public abstract void 
send(Chunk chunk) throws IP_Connection_Exception;  

public abstract int 
receive(byte[] m, int reserved, int length) throws IP_Connection_Exception;
public abstract int 
receive(byte[] m, int length) throws IP_Connection_Exception;
public abstract int 
receive(byte[] m) throws IP_Connection_Exception;
public abstract Chunk 
receive(int length) throws IP_Connection_Exception;

public void 
reserveHeaderSize(int size) throws IP_Connection_Exception {
  if (size < 0) 
    throw new IP_Connection_Exception("setHeaderSize(size): size < 0");

  upperHeaderReservation = size;
}

public int 
getHeaderSize() {
  return ownHeaderSize;
}

public abstract int getMaxSize();
public abstract void setMaxSize(int ms) throws Connection_Exception;

public void 
setRemoteAddress(Address addr) throws IP_Connection_Exception {
  remoteAddress = (IP_Address)addr;
}

public Address 
getRemoteAddress() {
  return remoteAddress;
}

public Address 
getLocalAddress() {
  return localAddress;
}

public abstract String getTypeName();



protected int ownHeaderSize;
protected int upperHeaderReservation;

protected IP_Address localAddress;

protected IP_Address remoteAddress;

}
